Name:           speech-tools
Version:        2.5
Release:        5%{?dist}
Summary:        Edinburgh speech tools library

License:        MIT
URL:            http://festvox.org
# Because of the copr build a https reachable mirror was needed
Source0: https://trycht.cz/festvox/packed/festival/%{version}/speech_tools-%{version}.0-release.tar.gz
Source1: LICENSE
Patch0: enable_shared.patch

BuildRequires:  gcc-c++ ncurses-devel alsa-lib-devel

%description
The Edinburgh speech tools system is a library of C++ classes, functions
and utility programs that are frequently used in speech software.
The system compiles to a single Unix library .a file
which can be linked with software.
At present, C++ classes for several useful speech and language classes
have been written, along with audio software
and some basic signal processing software.

%prep
%autosetup -n speech_tools -p 0

%build
%configure
# The following make invocation is necessary because configure does not honor the default compiler flags and ignoring those breaks the debuginfo package generation. Also, it disables problematic parallel make.
make CFLAGS="%{optflags} -fPIC" CXXFLAGS="%{optflags} -fPIC" LDFLAGS="$LDFLAGS"

%install
mkdir -p %{buildroot}%{_bindir}
# The installation will be handled by the license macro, but it must be somewhere where the paths add up
cp -p %{SOURCE1} .
# The list of installed utilities is taken from the Debian package
install -p -m 755 main/{bcat,ch_lab,ch_track,ch_utt,ch_wave,dp,na_play,na_record,ngram_build,ngram_test,ols,ols_test,pda,pitchmark,scfg_make,scfg_parse,scfg_test,scfg_train,sig2fv,sigfilter,spectgen,tilt_analysis,tilt_synthesis,viterbi,wagon,wagon_test,wfst_build,wfst_run} %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}
install -p -m 755 lib/*.so* %{buildroot}%{_libdir}
install -p -m 644 lib/*.a %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_includedir}/speech_tools
cp -dr include/* %{buildroot}%{_includedir}/speech_tools
rm -r %{buildroot}%{_includedir}/speech_tools/win32
# I would gladlylike to skip the internal details, but festival depends on them. 
mkdir -p %{buildroot}%{_libdir}/speech_tools/base_class
install -p -m 644 base_class/*.cc %{buildroot}%{_libdir}/speech_tools/base_class
install -p -m 644 base_class/*.h %{buildroot}%{_libdir}/speech_tools/base_class
mkdir -p %{buildroot}%{_libdir}/speech_tools
cp -dr config/ %{buildroot}%{_libdir}/speech_tools
mkdir -p %{buildroot}%{_libdir}/speech_tools/lib/siod
install -p -m 644 lib/siod/*.scm %{buildroot}%{_libdir}/speech_tools/lib/siod
# Note that a symlink would be nice below, but it breaks the expectations around dir traversal.
mkdir -p %{buildroot}%{_libdir}/speech_tools/include
cp -r %{buildroot}%{_includedir}/speech_tools/* %{buildroot}%{_libdir}/speech_tools/include

%files
%{_bindir}/*
%license LICENSE
    
%package libs
Summary: Edinburgh speech tools libraries

%description libs
The shared libraries needed by speech_tools and other software.

%ldconfig_scriptlets libs

%files libs
%{_libdir}/*.so*
%license LICENSE

%package libs-devel
Summary: Development files for the speech_tools libraries
Requires: speech_tools-libs%{?_isa} = %{version}-%{release}

%description libs-devel
This package contains the development related files for the speech_tools
libraries.

%files libs-devel
%{_includedir}/speech_tools/
%{_libdir}/speech_tools/
%{_libdir}/*.so

%package libs-static
Summary: Static libraries of speech_tools, so far needed by at least festival
Requires: speech_tools-libs-devel%{?_isa} = %{version}-%{release}

%description libs-static
This package contains the static libraries for speech_tools.
They are so far definitely needed for festival,
but they might be depended upon by some third-party developers as well.

%files libs-static
%{_libdir}/*.a

%changelog
* Tue Aug 28 2018 Lukáš Tyrychtr <lukastyrychtr@gmail.com> 2.5-5
- Use dash in package name - it makes every reviewer happier.

* Wed Jun 20 2018 Lukáš Tyrychtr <lukastyrychtr@gmail.com> 2.5-4
- Rename the library subpackages to the plural form
- Do not bundle static libraries in the devel subpackage
- Package tle LICENSE file properly

* Tue Apr 24 2018 Lukáš Tyrychtr <lukastyrychtr@gmail.com> 2.5-3
- Add the devel subpackage.

* Fri Apr 20 2018 Lukáš Tyrychtr <lukastyrychtr@gmail.com> 2.5-2
- Do not execute make in parallel.

* Wed Apr 18 2018 Lukáš Tyrychtr <lukastyrychtr@gmail.com> 2.5-1
 Initial release
